//
// Fab_med_dispenser_main_mod.ino
//
// Pallab Shrestha 08/01/21
//
// This work may be reproduced, modified, distributed,
// performed, and displayed for any purpose, but must
// acknowledge this project. Copyright is retained and
// must be preserved. The work is provided as is; no
// warranty is provided, and users accept all liability.
//

#include <WiFi.h>
#include <SPI.h>
#include <NTPClient.h>
#include <WiFiUdp.h>
#include <Servo_ESP32.h>
#include <BlynkSimpleEsp32.h>
#include <Wire.h>
#include "time.h"

#define servoPin 14 //printed G14 on the board
#define buzzer 27
#define hall 35
Servo_ESP32 servo1;


int angle = 100;
int angleMin = 100;
int angleMax = 170;
int angleStep = 1;

int med_qty = 0;
int buttonState = 0;
int setsec1 = 0;
int setsec2 = 0;
int setsec3 = 0;

int med_qty_sl1 = 0;
int buttonState_sl1 = 0;
int model1 = 0;
int setsec4 = 0;
int setsec5 = 0;
int setsec6 = 0;

int med_qty_sl2 = 0;
int buttonState_sl2 = 0;
int model2 = 0;
int setsec7 = 0;
int setsec8 = 0;
int setsec9 = 0;

char auth[] = "CXPXe4FBMq3APKm3-9C0hI5wrK1lKW5x";


const char* ssid     = "iPhone";                          //WiFi Name
const char* password = "NMF123!!!";                   // WiFi Password

WiFiUDP ntpUDP;
NTPClient timeClient(ntpUDP, "1.asia.pool.ntp.org", 19800);



void setup()
{
  Serial.begin(115200);
  Blynk.begin(auth, ssid, password);
  servo1.attach(servoPin);
  pinMode(buzzer, OUTPUT);
  pinMode(hall, INPUT);
  //connect to WiFi
  Serial.printf("Connecting to %s ", ssid);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println(" CONNECTED");
  Wire.begin();

}

void loop()
{
  timeClient.update();
  int h = timeClient.getHours();
  int m = timeClient.getMinutes();
  int s = timeClient.getSeconds();
  int actsec = h * 3600 + m * 60 + s;
  Serial.print(h);
  Serial.print(":");
  Serial.println(m);
  Blynk.run();
  Serial.println(setsec1);
  if (actsec == setsec4 || actsec == setsec5 || actsec == setsec6 || buttonState_sl1 == 1) {
    Wire.beginTransmission(model1);
    Wire.write(med_qty_sl1);
    Wire.endTransmission();
  }

    if (actsec == setsec7 || actsec == setsec8 || actsec == setsec9 || buttonState_sl2 == 1) {
    Wire.beginTransmission(model2);
    Wire.write(med_qty_sl2);
    Wire.endTransmission();
  }
  
  if (actsec == setsec1 || actsec == setsec2 || actsec == setsec3 || buttonState == 1) {
    dispense(med_qty);
    while (analogRead(hall) <= 3500) {
      buzz();
    }
  }
  delay(500);


}

void dispense(int med_qty) {
  for (int i = 1 ; i <= med_qty; i++) {
    for (int angle = angleMin; angle <= angleMax; angle += angleStep) {
      servo1.write(angle);
      Serial.println(angle);
      delay(20);
    }
    delay(100);

    for (int angle = angleMax; angle >= angleMin; angle -= angleStep) {
      servo1.write(angle);
      Serial.println(angle);
      delay(20);
    }
    delay(100);
  }
}

void buzz() {
  digitalWrite(buzzer, 1);
  delay(100);
  digitalWrite(buzzer, 0);
  delay(100);
}

BLYNK_WRITE(V0)
{
  med_qty = param.asInt(); // assigning incoming value from pin V1 to a variable
}

BLYNK_WRITE(V1) {
  TimeInputParam t(param);

  if (t.hasStartTime())
  {
    Serial.println(String("Start: ") +
                   t.getStartHour() + ":" +
                   t.getStartMinute() + ":" +
                   t.getStartSecond());
    setsec1 = (t.getStartHour() * 3600) + (t.getStartMinute() * 60) + t.getStartSecond();
  }
}

BLYNK_WRITE(V2) {
  TimeInputParam t(param);

  if (t.hasStartTime())
  {
    Serial.println(String("Start: ") +
                   t.getStartHour() + ":" +
                   t.getStartMinute() + ":" +
                   t.getStartSecond());
    setsec2 = (t.getStartHour() * 3600) + (t.getStartMinute() * 60) + t.getStartSecond();
  }
}

BLYNK_WRITE(V3) {
  TimeInputParam t(param);

  if (t.hasStartTime())
  {
    Serial.println(String("Start: ") +
                   t.getStartHour() + ":" +
                   t.getStartMinute() + ":" +
                   t.getStartSecond());
    setsec3 = (t.getStartHour() * 3600) + (t.getStartMinute() * 60) + t.getStartSecond();
  }
}

BLYNK_WRITE(V4)
{
  buttonState = param.asInt(); // assigning incoming value from pin V1 to a variable
}

BLYNK_WRITE(V5)
{
  model1 = param.asInt(); // assigning incoming value from pin V1 to a variable
}

BLYNK_WRITE(V6)
{
  med_qty_sl1 = param.asInt(); // assigning incoming value from pin V1 to a variable
}

BLYNK_WRITE(V7) {
  TimeInputParam t(param);

  if (t.hasStartTime())
  {
    Serial.println(String("Start: ") +
                   t.getStartHour() + ":" +
                   t.getStartMinute() + ":" +
                   t.getStartSecond());
    setsec4 = (t.getStartHour() * 3600) + (t.getStartMinute() * 60) + t.getStartSecond();
  }
}

BLYNK_WRITE(V8) {
  TimeInputParam t(param);

  if (t.hasStartTime())
  {
    Serial.println(String("Start: ") +
                   t.getStartHour() + ":" +
                   t.getStartMinute() + ":" +
                   t.getStartSecond());
    setsec5 = (t.getStartHour() * 3600) + (t.getStartMinute() * 60) + t.getStartSecond();
  }
}

BLYNK_WRITE(V9) {
  TimeInputParam t(param);

  if (t.hasStartTime())
  {
    Serial.println(String("Start: ") +
                   t.getStartHour() + ":" +
                   t.getStartMinute() + ":" +
                   t.getStartSecond());
    setsec6 = (t.getStartHour() * 3600) + (t.getStartMinute() * 60) + t.getStartSecond();
  }
}

BLYNK_WRITE(V10)
{
  buttonState_sl1 = param.asInt(); // assigning incoming value from pin V1 to a variable
}

BLYNK_WRITE(V11)
{
  model2 = param.asInt(); // assigning incoming value from pin V1 to a variable
}

BLYNK_WRITE(V12)
{
  med_qty_sl2 = param.asInt(); // assigning incoming value from pin V1 to a variable
}

BLYNK_WRITE(V13) {
  TimeInputParam t(param);

  if (t.hasStartTime())
  {
    Serial.println(String("Start: ") +
                   t.getStartHour() + ":" +
                   t.getStartMinute() + ":" +
                   t.getStartSecond());
    setsec7 = (t.getStartHour() * 3600) + (t.getStartMinute() * 60) + t.getStartSecond();
  }
}

BLYNK_WRITE(V14) {
  TimeInputParam t(param);

  if (t.hasStartTime())
  {
    Serial.println(String("Start: ") +
                   t.getStartHour() + ":" +
                   t.getStartMinute() + ":" +
                   t.getStartSecond());
    setsec8 = (t.getStartHour() * 3600) + (t.getStartMinute() * 60) + t.getStartSecond();
  }
}

BLYNK_WRITE(V15) {
  TimeInputParam t(param);

  if (t.hasStartTime())
  {
    Serial.println(String("Start: ") +
                   t.getStartHour() + ":" +
                   t.getStartMinute() + ":" +
                   t.getStartSecond());
    setsec9 = (t.getStartHour() * 3600) + (t.getStartMinute() * 60) + t.getStartSecond();
  }
}

BLYNK_WRITE(V16)
{
  buttonState_sl2 = param.asInt(); // assigning incoming value from pin V1 to a variable
}
